# ifdef		THINK_C
/*
*	FILE:		macapp.h
*	AUTHOR:		R. Gonzalez
*	CREATED:	August 28, 1990
*
*	Defines macintosh-specific application class.
*/

# ifndef	macapp_h
# define	macapp_h

# include	"app.h"
# include	"menubar.h"

# define	PARENT_CLASS	Mac_App

/************************************************************************
*	simple Macintosh-only application.
************************************************************************/
struct	Mac_App:Generic_App
{
	Menu_Bar		*menu_bar;
	
	boolean			init(void);
	void			run(void);
	void			query(char*,char[]);
	void			respond(char*);
	boolean			destroy(void);
};

# endif

# else
# include	"menapp.h"
# endif
	