/*
	Main.c
	
	Main file for Dragon projects
	
	Copyright  1992 by Paul M. Hoffman
	Send feedback to paul.hoffman@um.cc.umich.edu
	
	This code may be freely used, altered, and distributed in any way you want as long as:
		1.	It is GIVEN away rather than sold;
		2.	This statement and the above copyright notice are left intact.
	
	Created	24 Apr 1992	Extracted from Dragon.c
	Modified	01 May 1992	No longer calls Test  Dragon::Run will do so when debugging
	
*/

#include	"Dragon.h"

Dragon	*gDragon;		// This is it  the global dragon!

void main (void);
Dragon *CreateGDragon (void);

void main (void)
{
	gDragon = CreateGDragon ();
	if (gDragon != NULL) {
		gDragon->Start ();
		gDragon->Run ();
		gDragon->Finish ();
	}
}

