/*
*   FILE:    class.h
*   AUTHOR:  R.G.
*   CREATED: June 25, 1990
*   
*   header file defines Generic_Class and ensures Think C/C++
*	compatibility
*/

# ifndef	class_h			/* to avoid header reinclusion in C++ */
# define	class_h

# ifdef	THINK_C
# define	virtual			/* for TC/C++ compatibility */
# endif

# define	TRUE	1
# define	FALSE	0

typedef		int		boolean;

/******************************************************************
*   root class for all classes
******************************************************************/
# ifdef		THINK_C
struct  Generic_Class:indirect
# else
struct	Generic_Class		/* for TC/C++ compatibility */
# endif
{
    virtual	boolean	init(void);
    virtual	boolean	destroy(void);
};

# endif

